require 'active_support/concern'
require 'active_support/callbacks'

module Gemthief
  class Executive
    module Callbacks
      extend ActiveSupport::Concern
      include ActiveSupport::Callbacks

      CALLBACKS = [:start, :finish]

      included do
        define_callbacks *CALLBACKS
      end

      module ClassMethods
        [:before, :around, :after].product(CALLBACKS).each do |type, callback|
          define_method("#{type}_#{callback}") do |&block|
            set_callback callback, type, &block
          end
        end
      end
    end
  end
end
