module Gemthief
  class Scene
    class << self
      attr_reader :view_name
      def default_view(view=nil)
        return @view_name if view.nil?

        @view_name = case view
        when Class  then view.name.underscore
        when String then view
        when Symbol then view
        end
      end
    end

    def view
      @view ||= begin
        view_name = if self.class.view_name.nil?
          self.class.name.gsub(/Scene$/, "")
        else
          self.class.view_name
        end
        view_class = view_name.to_s.camelize + "View"
        view_class.constantize.new(Gemthief.game.root_window)
      end
    end

    def initialize
      super
      view
    end
  end
end
